<template>
  <div>
    <v-select
      v-if="!shapesLoading && !shapesError && shapes.length > 0"
      v-model="selectedSchema"
      :items="shapes"
      label="Select Schema"
    ></v-select>
  </div>
  <div>
    <v-select
      v-if="!schemaLoading && !schemaError && schemaInfo"
      v-model="selectedShapeName"
      :items="computedShapeList"
      label="Select Shape"
    ></v-select>
  </div>
  <div class="m-auto w-full" v-if="selectedShape && !schemaLoading && !schemaError && schemaInfo">
    <JsonForms :data="formData" :schema="selectedShape" :renderers="renderers" @change="onChange" />
  </div>
  <div>
    <v-btn :disabled="submitDisabled" @click="onSubmit">Submit</v-btn>
  </div>
</template>

<script setup lang="ts">
import { publishSelfDescription } from '@/api/localApi';
import { useShapeData, useShapes } from '@/components/sdForm/util';
import { formatDataToJsonLd, type ExtendedJsonSchema4 } from '@/util/schema/jsonld';
import accessPolicyTester from '@/util/schema/testers/accessPolicy';
import { JsonForms, type JsonFormsChangeEvent } from '@jsonforms/vue';
import { vuetifyRenderers } from '@jsonforms/vue-vuetify';
import { computed, ref, toValue, watch } from 'vue';
import AccessPolicy from './renderers/AccessPolicy.vue';

import 'vuetify/styles';

const renderers = Object.freeze([
  ...vuetifyRenderers,
  { tester: accessPolicyTester, renderer: AccessPolicy },
]);
const formData = ref<any>({});

const selectedSchema = ref<string | undefined>(undefined);
const selectedShapeName = ref<string | undefined>(undefined);
const formErrors = ref<any[]>();

const { data: shapes, isLoading: shapesLoading, error: shapesError } = useShapes();
const {
  data: schemaInfo,
  isLoading: schemaLoading,
  error: schemaError,
} = useShapeData(selectedSchema);

const computedShapeList = computed(() => {
  return schemaInfo.value ? Object.keys(schemaInfo.value.root) : [];
});

const prefixes = computed(() => {
  return schemaInfo.value ? Object.assign({}, schemaInfo.value.prefixes) : {};
});

const schemas = computed(() => {
  return schemaInfo.value ? Object.assign({}, schemaInfo.value.root) : {};
});

const selectedShape = computed(() => {
  return selectedShapeName.value ? schemas.value[selectedShapeName.value] : undefined;
});

watch(selectedSchema, () => {
  selectedShapeName.value = undefined;
});

const onChange = async (event: JsonFormsChangeEvent) => {
  formData.value = event.data;
  formErrors.value = event.errors;
};

const submitDisabled = computed(() => {
  if (!formErrors.value) {
    return true;
  }

  return formErrors.value.length !== 0;
});

const onSubmit = async () => {
  const value = JSON.parse(JSON.stringify(formData.value));
  if (selectedShape.value) {
    const formattedJsonLd = await formatDataToJsonLd(
      value,
      Object.assign({}, selectedShape.value as ExtendedJsonSchema4),
      toValue(prefixes)
    );
    const response = await publishSelfDescription(formattedJsonLd);
    console.log('RESPONSE:', response);
  }
};
</script>
